if select(6, GetAddOnInfo("PitBull_" .. (debugstack():match("[i%.][t%.][B%.]ull\\Modules\\(.-)\\") or debugstack():match("[i%.][t%.][B%.]ull\\(.-)\\") or ""))) ~= "MISSING" then return end

local VERSION = tonumber(("$Revision: 39962 $"):match("%d+"))

local PitBull = PitBull
local PitBull_CombatIcon = PitBull:NewModule("CombatIcon", "AceEvent-2.0")
local self = PitBull_CombatIcon
if PitBull.revision < VERSION then
	PitBull.version = "r" .. VERSION
	PitBull.revision = VERSION
	PitBull.date = ("$Date: 2007-06-14 21:09:38 -0400 (Thu, 14 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end
self.desc = "Show an icon based on whether or not the unit is in combat."

-- localization placeholder
local L = PitBull:L("PitBull-CombatIcon")

local new, del, newHash = PitBull.new, PitBull.del, PitBull.newHash
local newFrame, delFrame = PitBull.newFrame, PitBull.delFrame

PitBull_CombatIcon:RegisterPitBullChildFrames('combatIcon')

function PitBull_CombatIcon:OnInitialize()
	self.db = PitBull:AcquireDBNamespace("CombatIcon")
	PitBull:RegisterDefaults("CombatIcon", "profile", {
		groups = {
			['**'] = { disable = true },
			["player"] = {
				disable = false,
			},
			["target"] = {
				disable = false,
			},
			["party"] = {
				disable = false,
			},
		},
	})
end

function PitBull_CombatIcon:OnEnable()
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "PLAYER_REGEN_ENABLED")
	
	self:ScheduleRepeatingEvent("PitBull_CombatIcon-Update", self.UpdateAllNonWacky, 0.5, self)
end

function PitBull_CombatIcon:PLAYER_REGEN_ENABLED()
	for frame in PitBull:IterateUnitFramesForUnit('player') do
		self:Update('player', frame)
	end
end

local alerted = false
function PitBull_CombatIcon:Update(unit, frame)
	if not frame.group then
		if not alerted then
			AceLibrary("AceConsole-2.0"):Print("Error in PitBull_CombatIcon, please report this to ckknight:", debugstack())
			alerted = true
		end
		return
	end
	if self.db.profile.groups[frame.group].disable then return end

	local inCombat = UnitAffectingCombat(unit)
	if PitBull.configMode and not UnitExists(unit) then
		inCombat = true
	end
	
	if inCombat then
		if not frame.combatIcon then
			frame.combatIcon = newFrame("Texture", frame.overlay, "ARTWORK")
			frame.combatIcon:SetTexture("Interface\\CharacterFrame\\UI-StateIcon")
			frame.combatIcon:SetTexCoord(0.5, 1, 0, 0.5)
			frame.combatIcon:Hide()
			PitBull:UpdateLayout(frame)
		end
	else
		if frame.combatIcon then
			frame.combatIcon = delFrame(frame.combatIcon)
			
			PitBull:UpdateLayout(frame)
		end
	end
end

function PitBull_CombatIcon:UpdateAllNonWacky()
	for unit, frame in PitBull:IterateNonWackyUnitFrames() do
		self:Update(unit, frame)
	end
end

function PitBull_CombatIcon:OnUpdateFrame(unit, frame)
	self:Update(unit, frame)
end

function PitBull_CombatIcon:OnClearUnitFrame(unit, frame)
	if frame.combatIcon then
		frame.combatIcon = delFrame(frame.combatIcon)
	end
end

function PitBull_CombatIcon:OnUnknownLayout(unit, frame)
	frame.combatIcon:SetPoint("CENTER", frame, "BOTTOMLEFT", 0, 0)
	frame.combatIcon:SetWidth(18)
	frame.combatIcon:SetHeight(18)
end

-- Unit/Group Specific Options
local function getEnabled(group)
	return not PitBull_CombatIcon.db.profile.groups[group].disable
end
local function setEnabled(group, value)
	value = not value
	PitBull_CombatIcon.db.profile.groups[group].disable = value
	if value then
		for unit,frame in PitBull:IterateUnitFramesByGroup(group) do
			if frame.combatIcon then
				frame.combatIcon = delFrame(frame.combatIcon)
				PitBull:UpdateLayout(frame)
			end
		end
	else
		for unit,frame in PitBull:IterateUnitFramesByGroup(group) do
			if not frame.combatIcon then
				self:Update(unit, frame)
			end
		end
	end
end

PitBull_CombatIcon:RegisterPitBullOptionsMethod(function(group)
	return {
		type = "toggle",
		name = L["Enable in-combat icon"],
		desc = L["Enables the in-combat indicator for this unit."],
		get = getEnabled,
		set = setEnabled,
		passValue = group,
	}
end)
